## Script (Python) "apply_pume"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST
##title=
##
# $Id: apply_pume.py 2098 2007-08-15 16:22:25Z joachim $
"""
process the Pume Application Form
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

import DateTime
current = DateTime.DateTime()
pr = context.portal_registration
request = REQUEST

#type_name = 'StudentApplication'
#ti = context.portal_types[type_name]
#REQUEST.set('type_name',type_name)
create = "create" in request.keys()
apply_pume = "apply" in request.keys()
edit = "edit" in request.keys()
mode = request.get('mode','')
if not mode:
    if apply_pume or edit:
        mode = "edit"
    else:
        mode = "create"
validate = create or edit or apply_pume

lt = context.portal_layouts
reg_no = request.get('widget__reg_no','').upper()
if not reg_no:
    reg_no = request.get('reg_no','').upper()
    
object = {}
#set_trace()
if reg_no:
    brains = context.applicants_catalog(reg_no = reg_no)
    if len(brains) == 1:
        for field in context.applicants_catalog.schema():
            object[field] = getattr(brains[0],field,None)

res,psm,ds = lt.renderLayout(layout_id= 'application',
                             schema_id= 'application',
                             layout_mode = mode,
                             context=context,
                             mapping=validate and REQUEST,
                             ob=object,
                             commit = False,
                            )

if psm == 'invalid':
    return context.apply_pume_form(rendered = res,
                                   psm = "Please correct your input!",
                                   #psm = "%s, %s" % (psm,ds),
                                   mode = mode,
                                   ds = ds,
                                  )
elif psm == '':
    return context.apply_pume_form(rendered = res,
                                   psm = None,
                                   ds = ds,
                                   mode = mode,
                                  )
elif psm == 'valid':
    pass
if create or edit or apply_pume:
    data = {}
    for field in context.applicants_catalog.schema():
        if ds.has_key(field) and request.has_key("widget__%s" % field):
            data[field] = ds.get(field)
    data['reg_no'] = reg_no
    if apply_pume:
        data['registration_date'] = current
        data['status'] = "submitted"
    context.applicants_catalog.modifyRecord(**data)
    if apply_pume:
        if not request.has_key('confirm'):
            return context.apply_pume_form(rendered = res,
                                        psm = "Please confirm Passport Photograph",
                                        #psm = "%s, %s" % (psm,ds),
                                        mode = mode,
                                        ds = ds,
                                        )
                    
        return request.RESPONSE.redirect("%s/apply_pume?mode=view&reg_no=%s" %
                                     (context.absolute_url(),ds.get('reg_no')))
    elif edit or create:
        return request.RESPONSE.redirect("%s/apply_pume?mode=edit&reg_no=%s" %
                                     (context.absolute_url(),ds.get('reg_no')))


